//+------------------------------------------------------------------+
//|                                                           rsx ma |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -101
#property indicator_maximum  101
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    RsxPeriod   = 14;
extern int    RsxPrice    = PRICE_CLOSE;
extern double Sensitivity = 1;
extern bool   Interpolate = true;

//
//
//
//
//

double values[];
double valuesDa[];
double valuesDb[];
double trend[];
string indicatorFileName;
int    timeFrame;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,values);
      SetIndexBuffer(1,valuesDa);
      SetIndexBuffer(2,valuesDb);
      SetIndexBuffer(3,trend);
         timeFrame         = stringToTimeFrame(TimeFrame);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   IndicatorShortName(timeFrameToString(timeFrame)+" rsx ma ("+RsxPeriod+")");
   return(0); 
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double  workRsx[][14];
#define _rsx 13

//
//
//
//
//

int start()
{
   int    i,r,limit,counted_bars=IndicatorCounted();

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { values[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               
               limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               if (trend[limit]==-1) CleanPoint(limit,valuesDa,valuesDb);
               for (i=limit;i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     values[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxPeriod,RsxPrice,Sensitivity,0,y);
                     trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsxPeriod,RsxPrice,Sensitivity,3,y);
                     valuesDa[i] = EMPTY_VALUE;
                     valuesDb[i] = EMPTY_VALUE;
               
                     //
                     //
                     //
                     //
                     //
                        
                     if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,timeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
                        for(int k = 1; k < n; k++)
                        {
                           values[i+k] = values[i] + (values[i+n]-values[i])*k/n;
                        }
               }
               for (i=limit;i>=0; i--) if (trend[i]==-1) PlotPoint(i,valuesDa,valuesDb,values);
               return(0);
            }               

   //
   //
   //
   //
   //

      if (ArrayRange(workRsx,0) != Bars) ArrayResize(workRsx,Bars);

      double Kg = (3.0)/(2.0+RsxPeriod); 
      double Hg = 1.0-Kg;

   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,valuesDa,valuesDb);
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      workRsx[r][12] = iMA(NULL,0,1,0,MODE_SMA,RsxPrice,i);
         if (i==(Bars-1)) { for (int c=0; c<12; c++) workRsx[r][c] = 0; continue; }  
   
         //
         //
         //
         //
         //
      
         double mom = workRsx[r][12]-workRsx[r-1][12];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
               workRsx[r][kk+0] = Kg*mom              + Hg*workRsx[r-1][kk+0];
               workRsx[r][kk+1] = Kg*workRsx[r][kk+0] + Hg*workRsx[r-1][kk+1]; mom = 1.5*workRsx[r][kk+0] - 0.5*workRsx[r][kk+1];
               workRsx[r][kk+6] = Kg*moa              + Hg*workRsx[r-1][kk+6];
               workRsx[r][kk+7] = Kg*workRsx[r][kk+6] + Hg*workRsx[r-1][kk+7]; moa = 1.5*workRsx[r][kk+6] - 0.5*workRsx[r][kk+7];
         }
         if (moa != 0)
              workRsx[r][_rsx] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
         else workRsx[r][_rsx] = 50.0;
   }
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double slope  = 0;
      double value = 0;
      double maNow  = iMA(NULL,0,RsxPeriod,0,MODE_EMA,PRICE_WEIGHTED,i);
      double maPre  = iMA(NULL,0,RsxPeriod,0,MODE_EMA,PRICE_WEIGHTED,i+1);
         if (maNow>maPre) { slope =  1; value =     workRsx[r][_rsx]; }
         if (maNow<maPre) { slope = -1; value = 100-workRsx[r][_rsx]; }
            values[i]   = MathMax(MathMin(Sensitivity*value*slope,100),-100);
            valuesDa[i] = EMPTY_VALUE;
            valuesDb[i] = EMPTY_VALUE;
            trend[i]    = trend[i+1];

            if (values[i]>values[i+1]) trend[i] =  1;
            if (values[i]<values[i+1]) trend[i] = -1;
            if (trend[i]==-1) PlotPoint(i,valuesDa,valuesDb,values);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}